#version 330 core

layout(location = 0) in vec4 vertexPosition;
layout(location = 1) in vec2 vertexTexCoord;
layout(location = 2) in vec3 vertexNormal;
layout(location = 3) in vec4 vertexColor;
uniform mat4 mvp;
uniform mat4 view;
uniform mat4 model;
uniform mat4 projection;

out vec2 texCoord;


out vec3 N;
out vec3 v;


void main()
{
   texCoord = vertexTexCoord;
   
   v = mat3(model)*vertexNormal;
   N = mat3(model)*vertexNormal;
   gl_Position = mvp * vertexPosition;
}

